﻿Imports System
Imports Microsoft

Module ReaderModeVB
  Function MakeString(NamenListe() As Byte,StringNummer As Integer) As String
    MakeString = ""
    Dim i As Integer
    Dim StringFound As Boolean

    Dim aktStringNummer As Integer
    i = 0
    aktStringNummer = 0
    While (aktStringNummer <= StringNummer)
      MakeString = ""
      StringFound = False

      While (i < NamenListe.Length) And StringFound = False
        If (NamenListe(i) <> 0) Then
          MakeString = MakeString & Chr(NamenListe(i))
        Else
          StringFound = True
        End If
        i = i + 1
      End While
      If (MakeString.Length = 0)
        aktStringNummer = StringNummer+1
      End If
      aktStringNummer = aktStringNummer + 1
    End While
  End Function

  Function MakeArray(Name As String) As Byte()
    Dim i As Integer
    i = 0
    Dim NewArray(Name.Length) As Byte
    While i < Name.Length
      NewArray.SetValue(Convert.ToByte(Name(i)),i)
      i = i + 1
    End While
    MakeArray = NewArray
  End Function

  Sub CopyArrayTo(Src() As Byte, ByVal SrcOffset As Integer, Dest() As Byte, ByVal DestOffset As Integer, ByVal Len As Integer)
    While Len > 0
      Dest(DestOffset) = Src(SrcOffset)
      DestOffset = DestOffset + 1
      SrcOffset = SrcOffset + 1
      Len = Len - 1
    End While
  End Sub

  Dim LastVal As String
  Dim bGood As Integer

  Public Function onAutoread(Arr As String, Len As Integer) As Integer
    If Len = 0
      bGood = -1
    Else
      Console.Out.Write("Received: ")
      Console.Out.Write(Arr)
      Console.Out.WriteLine()

      If (LastVal.Length = 0)
        LastVal = Arr
        bGood = 1
      Else
        If (Arr = LastVal)
          bGood = 2
        Else
          bGood = 3
        End If
      End If
    End If
    onAutoread = 0
  End Function

  Sub Main()
    Dim MaxLen As Integer
    Dim ListLen As Integer
    Dim DevListLen As Integer
    MaxLen = 255
    ListLen = 0
    DevListLen = 0

    Dim DevList(255) As Byte
    Dim NamenListe(1000) As Byte

    Dim AutoReadProc As AutoReadCallback 
    AutoReadProc = New AutoReadCallback(AddressOf onAutoread)

    DevListLen = TSURW_GetCOMDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    DevListLen = TSURW_GetUSBDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    DevListLen = TSURW_GetLanDeviceNames(DevList(0), MaxLen) - 1
    CopyArrayTo(DevList, 0, NamenListe, ListLen, DevListLen)
    ListLen = DevListLen + ListLen
    ListLen = ListLen + 1

    LastVal = ""
    bGood = 0

    If (ListLen > 1) Then
      Console.Out.Write("Device found ")
      Dim DeviceName As String
      Dim DeviceCount As Integer
      Dim DeviceNr As Integer
      Dim DeviceNameArr(255) As Byte
      DeviceCount = 0
      Do
        DeviceName = MakeString(NamenListe,DeviceCount)
        If (DeviceName.Length > 0)
          Console.Out.Write("Device {0,0:D} ", DeviceCount + 1)
          Console.Out.Write(DeviceName)
          Console.Out.WriteLine()
        End If
        DeviceCount = DeviceCount + 1
      Loop While DeviceName.Length > 0

      Console.Out.Write("Select Device:")
      DeviceNr = Convert.ToInt32(Console.In.ReadLine())

      DeviceName = MakeString(NamenListe, DeviceNr - 1)
      DeviceNameArr = MakeArray(DeviceName)

      Console.Out.Write(DeviceName)
      Console.Out.WriteLine()

      Dim Handle = TSURW_Open(DeviceNameArr(0), 19200, 0, 500)
      If (Handle > 0) Then

        ' If Reader is possible, then
        ' activate Reader Mode, because the device might anyway be set to Programmer mode
        TSURW_SetReaderMode(Handle, 1)

        TSURW_StartAutoRead(Handle, &H0D, AutoReadProc)
        Dim StopIt = 0
        While Not Console.KeyAvailable And StopIt = 0
          System.Threading.Thread.Sleep(100)
          If (bGood = 1)
            TSURW_SetLED(Handle, 0, 1, 0)
            bGood = 0
          Else If (bGood = 2)
            TSURW_SetLED(Handle, 1, 0, 0)
            TSURW_Beep(Handle)
            bGood = 0
          Else If (bGood = 3)
            TSURW_SetLED(Handle, 0, 0, 1)
            bGood = 0
          Else If (bGood = -1)
            ' Reader was removed
            ' Leave this
            Console.Out.WriteLine("Fatal Error: Device was Removed.")
            Console.Out.WriteLine("Press Key to continue")
            StopIt = 1
          End If
        End While

        TSURW_SetLED(Handle, 2, 2, 2)
        TSURW_StopAutoRead(Handle)
        Console.ReadKey
        
        TSURW_Close(Handle)
      End If
    End If
    Console.Out.Write("Wait for Key to exit")
    While Not Console.KeyAvailable
    End While

  End Sub

End Module
