
// TS_URW_DemoVCDlg.h: Headerdatei
//

#pragma once
#include "afxwin.h"


// CTS_URW_DemoVCDlg-Dialogfeld
class CTS_URW_DemoVCDlg : public CDialogEx
{
// Konstruktion
public:
	CTS_URW_DemoVCDlg(CWnd* pParent = NULL);	// Standardkonstruktor

// Dialogfelddaten
	enum { IDD = IDD_TS_URW_DEMOVC_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung

  bool OpenIfNeeded();
  void CloseIfOpen();
  CString MakeStringFromArray(char Arr[], int ArrLength, int &StartIdx);
  CString MakeStringFromData(byte Arr[], int StartIdx, int EndIdx);
  int MakeArrayFromString(char Arr[], CString str);
  byte MakeHex(TCHAR high, TCHAR low);
  int MakeDataFromString(byte Arr[], int ArrLength, CString str);

// Implementierung
protected:
	HICON m_hIcon;
  int   m_myHandle;

	// Generierte Funktionen fr die Meldungstabellen
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
  int m_StartByte;
  int m_Length;
  CString m_Data;
  CString m_Inventory;
  CListBox m_DeviceList;
  CComboBox m_MemoryBank;
  virtual BOOL DestroyWindow();
  afx_msg void OnClickedReadData();
  afx_msg void OnClickedReadInventory();
  afx_msg void OnClickedWriteData();
  afx_msg void OnClickedScan();
  afx_msg void OnClickedAutoread();
  CStatic m_StatusCtrl;
};
