
// TS_URW_InventoryVCDlg.h: Headerdatei
//

#pragma once
#include "afxwin.h"


// CTS_URW_InventoryVCDlg-Dialogfeld
class CTS_URW_InventoryVCDlg : public CDialogEx
{
// Konstruktion
public:
	CTS_URW_InventoryVCDlg(CWnd* pParent = NULL);	// Standardkonstruktor

// Dialogfelddaten
	enum { IDD = IDD_TS_URW_INVENTORYVC_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV-Untersttzung

  bool OpenIfNeeded();
  void CloseIfOpen();
  CString MakeStringFromArray(char Arr[], int ArrLength, int &StartIdx);
  CString MakeStringFromData(byte Arr[], int StartIdx, int EndIdx);
  int MakeArrayFromString(char Arr[], CString str);
  byte MakeHex(TCHAR high, TCHAR low);
  int MakeDataFromString(byte Arr[], int ArrLength, CString str);

// Implementierung
protected:
	HICON m_hIcon;
  CPoint m_MinSize;
  int   m_myHandle;
  bool  m_bURW39;

	// Generierte Funktionen fr die Meldungstabellen
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
  CString m_Inventory;
  CListBox m_DeviceList;
  virtual BOOL DestroyWindow();
  afx_msg void OnReadInventory();
  afx_msg void OnScan();
  CStatic m_StatusCtrl;
  CListCtrl m_InventoryList;
  afx_msg void OnReadInventoryRssi();
  afx_msg void OnSelchangeDeviceList();
  CString m_DeviceName;
  afx_msg void OnGetMinMaxInfo(MINMAXINFO* lpMMI);
};
